import { Description } from "./Description";
import { PointDescription } from "./PointDescription";
import { RectDescription } from "./RectDescription";
import { SeriesDescription } from "./SeriesDescription";
import { Type } from "./type";
export declare abstract class SeriesViewerDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private h;
    crosshairPoint: PointDescription;
    private r;
    animateSeriesWhenAxisRangeChanges: boolean;
    private k;
    effectiveViewport: RectDescription;
    private m;
    windowRect: RectDescription;
    private y;
    useTiledZooming: boolean;
    private v;
    preferHigherResolutionTiles: boolean;
    private bs;
    zoomTileCacheSize: number;
    private br;
    highlightingTransitionDuration: number;
    private t;
    isPagePanningAllowed: boolean;
    private bx;
    contentHitTestMode: string;
    private bv;
    actualContentHitTestMode: string;
    private u;
    isSurfaceInteractionDisabled: boolean;
    private cd;
    windowResponse: string;
    private a3;
    windowRectMinWidth: number;
    private b2;
    overviewPlusDetailPaneVisibility: string;
    private by;
    crosshairVisibility: string;
    private b4;
    plotAreaBackground: string;
    private bz;
    defaultInteraction: string;
    private b0;
    dragModifier: string;
    private b3;
    panModifier: string;
    private l;
    previewRect: RectDescription;
    private a1;
    windowPositionHorizontal: number;
    private a2;
    windowPositionVertical: number;
    private bw;
    chartTitle: string;
    private ca;
    titleHorizontalAlignment: string;
    private b6;
    subtitleHorizontalAlignment: string;
    private cc;
    titleTextStyle: string;
    private b8;
    subtitleTextStyle: string;
    private cb;
    titleTextColor: string;
    private b7;
    subtitleTextColor: string;
    private az;
    titleTopMargin: number;
    private ax;
    titleLeftMargin: number;
    private ay;
    titleRightMargin: number;
    private aw;
    titleBottomMargin: number;
    private av;
    subtitleTopMargin: number;
    private at;
    subtitleLeftMargin: number;
    private au;
    subtitleRightMargin: number;
    private as;
    subtitleBottomMargin: number;
    private b5;
    subtitle: string;
    private b9;
    syncChannel: string;
    private x;
    synchronizeVertically: boolean;
    private w;
    synchronizeHorizontally: boolean;
    private a0;
    topMargin: number;
    private ap;
    leftMargin: number;
    private ar;
    rightMargin: number;
    private an;
    bottomMargin: number;
    private am;
    autoMarginWidth: number;
    private al;
    autoMarginHeight: number;
    private s;
    isAntiAliasingEnabledDuringInteraction: boolean;
    private aq;
    pixelScalingRatio: number;
    private ao;
    interactionPixelScalingRatio: number;
    private b1;
    overviewPlusDetailPaneBackgroundImageUri: string;
    private ai;
    actualPixelScalingRatio: number;
    private ah;
    actualInteractionPixelScalingRatio: number;
    private j;
    actualWindowRect: RectDescription;
    private aj;
    actualWindowPositionHorizontal: number;
    private ak;
    actualWindowPositionVertical: number;
    private _SeriesCursorMouseMoveRef;
    SeriesCursorMouseMoveRef: string;
    private _SeriesMouseLeftButtonDownRef;
    SeriesMouseLeftButtonDownRef: string;
    private _SeriesMouseLeftButtonUpRef;
    SeriesMouseLeftButtonUpRef: string;
    private _SeriesMouseMoveRef;
    SeriesMouseMoveRef: string;
    private _SeriesMouseEnterRef;
    SeriesMouseEnterRef: string;
    private _SeriesMouseLeaveRef;
    SeriesMouseLeaveRef: string;
    private _WindowRectChangedRef;
    WindowRectChangedRef: string;
    private _SizeChangedRef;
    SizeChangedRef: string;
    private _GridAreaRectChangedRef;
    GridAreaRectChangedRef: string;
    private f;
    series: SeriesDescription[];
}
